<?php
include "common.inc.php";

# Open DB
$db = OpenDB();

function cmp($a, $b)
{
    if ($a == $b) {
        return 0;
    }
    return ($a < $b) ? -1 : 1;
}

$timeSlice = intval($_GET["timeSlice"]);
if($timeSlice < 5) {
    $timeSlice = 60;
}

if($_GET["statType"] == 'topBlockedRules') {
    require_once('OFC/OFC_Chart.php');

    $min = 9999999999999;
    $max = 0;

    $result = mysql_query("SELECT DISTINCT(t1.RulesID),t2.Type,t2.Value FROM DB_Events AS t1 INNER JOIN DB_Rules AS t2 ON t1.RulesID=t2.ID WHERE TIMESTAMPDIFF(MINUTE,t1.AddDate,NOW()) < $timeSlice AND t2.Action='BLOCK';");
    if($result === false) {
	printf("Errore Mysql: %s\n",mysql_error());
	exit();
    }

    if(mysql_num_rows($result) > 0) {
	while($row = mysql_fetch_row($result)) {
    	    $val = intval($row[0]);
    	    $myRule = $row[1]."=".$row[2];
    	    if($val < $min) {
    		$min = $val;
    	    }
    	    if($val > $max) {
    		$max = $val;
    	    }
	    uasort($values, "cmp");
	    $values[$myRule] = $val;
    	    if(count($values) > 10) {
		array_shift($values);
	    }
	}
    } else {
	$values[0] = 0;
    }

    $values = array_reverse($values);

    $title = new OFC_Elements_Title( "Top ten block rules in last $timeSlice mins" );
    $title->set_style( "{font-size: 15px; font-weight: bold; color: #333333; text-align: center;}" );

    $bar = new OFC_Charts_Bar_3d();
    $bar->set_values(array_values($values));
    $bar->colour = '#D54C78';

    $y_axis = new OFC_Elements_Axis_Y();
    if($max-$min > 10) {
	$y_axis->set_range( $min, $max+1, round(($max-$min) / 10));
    } else {
	$y_axis->set_range( $min, $max+1, 1);    
    }

    $x_axis = new OFC_Elements_Axis_X();
    $x_axis->set_3d(3);
    $x_axis->colour = '#909090';
    $x_axis->set_labels_from_array(array_keys($values));
    $x_axis->labels->set_vertical();

    $chart = new OFC_Chart();
    $chart->set_bg_colour( '#EEEEEE' );
    $chart->set_title( $title );
    $chart->add_element( $bar );
    $chart->set_y_axis( $y_axis );
    $chart->set_x_axis( $x_axis );

    echo $chart->toPrettyString();
    exit(1);
}

if($_GET["statType"] == 'topBlockedUsers') {
    require_once('OFC/OFC_Chart.php');

    $min = 9999999999999;
    $max = 0;

    $result = mysql_query("SELECT Ident,COUNT(Ident) FROM DB_Events WHERE TIMESTAMPDIFF(MINUTE,AddDate,NOW()) < $timeSlice GROUP BY Ident ORDER BY Ident;");
    if($result === false) {
	printf("Errore Mysql: %s\n",mysql_error());
	exit();
    }

    if(mysql_num_rows($result) > 0) {
	while($row = mysql_fetch_row($result)) {
	    $myIdent = stripslashes($row[0]);
    	    $val = intval($row[1]);
    	    
    	    if($val < $min) {
    		$min = $val;
    	    }
    	    if($val > $max) {
    		$max = $val;
    	    }
	    uasort($values, "cmp");
	    $values[$myIdent] = $val;
    	    if(count($values) > 10) {
		array_shift($values);
	    }
	}
    } else {
	$values[0] = 0;
    }

    $values = array_reverse($values);

    $title = new OFC_Elements_Title( "Top ten blocked users in last $timeSlice mins" );
    $title->set_style( "{font-size: 15px; font-weight: bold; color: #333333; text-align: center;}" );

    $bar = new OFC_Charts_Bar_3d();
    $bar->set_values(array_values($values));
    $bar->colour = '#D54C78';

    $y_axis = new OFC_Elements_Axis_Y();
    if($max-$min > 10) {
	$y_axis->set_range( $min, $max+1, round(($max-$min) / 10));
    } else {
	$y_axis->set_range( $min, $max+1, 1);    
    }

    $x_axis = new OFC_Elements_Axis_X();
    $x_axis->set_3d(3);
    $x_axis->colour = '#909090';
    $x_axis->set_labels_from_array(array_keys($values));
    $x_axis->labels->set_vertical();

    $chart = new OFC_Chart();
    $chart->set_bg_colour( '#EEEEEE' );
    $chart->set_title( $title );
    $chart->add_element( $bar );
    $chart->set_y_axis( $y_axis );
    $chart->set_x_axis( $x_axis );

    echo $chart->toPrettyString();
    exit(1);
}

if($_GET["statType"] == 'topTen') {
    require_once('OFC/OFC_Chart.php');

    $min = 9999999999999;
    $max = 0;

    $result = mysql_query("SELECT DISTINCT(Domain) FROM DB_Access WHERE TIMESTAMPDIFF(MINUTE,AddDate,NOW()) < $timeSlice ORDER BY Domain;");
    if($result === false) {
	printf("Errore Mysql: %s\n",mysql_error());
	exit();
    }
    
    $values = array();
    
    if(mysql_num_rows($result) > 0) {
	while($row = mysql_fetch_row($result)) {
	    $myDomain = stripslashes($row[0]);
	    $domResult = mysql_query("SELECT COUNT(*) FROM DB_Access WHERE TIMESTAMPDIFF(MINUTE,AddDate,NOW()) < $timeSlice AND Domain='$myDomain';");
    	    $row = mysql_fetch_row($domResult);
    	    $val = intval($row[0]);
    	    if($val < $min) {
    		$min = $val;
    	    }
    	    if($val > $max) {
    		$max = $val;
    	    }
	    uasort($values, "cmp");
	    $values[$myDomain] = $val;
    	    if(count($values) > 10) {
		array_shift($values);
	    }
	}
    } else {
	$values[0] = 0;
    }

    $values = array_reverse($values);

    $title = new OFC_Elements_Title( "Top ten connections in last $timeSlice mins" );
    $title->set_style( "{font-size: 15px; font-weight: bold; color: #333333; text-align: center;}" );

    $bar = new OFC_Charts_Bar_3d();
    $bar->set_values(array_values($values));
    $bar->colour = '#D54C78';

    $y_axis = new OFC_Elements_Axis_Y();
    $y_axis->set_range( $min, $max+1, round(($max-$min) / 10));

    $x_axis = new OFC_Elements_Axis_X();
    $x_axis->set_3d(3);
    $x_axis->colour = '#909090';
    $x_axis->set_labels_from_array(array_keys($values));
    $x_axis->labels->set_vertical();

    $chart = new OFC_Chart();
    $chart->set_bg_colour( '#EEEEEE' );
    $chart->set_title( $title );
    $chart->add_element( $bar );
    $chart->set_y_axis( $y_axis );
    $chart->set_x_axis( $x_axis );

    echo $chart->toPrettyString();
    exit(1);
}

$authRequired = 1; /* This page can be accessed only by administrators */

include "common_header.php";

$graphType = $_GET["graphType"];
if($graphType == '') {
    $graphType = 'topTen';
}

echo "
<script type='text/javascript' src='./js/swfobject.js'></script>
<div id='connectionStats' style='text-align: center;'></div>
<script type='text/javascript'>
        var so = new SWFObject('./open-flash-chart.swf', 'ofc', '700', '400', '9', '#FFFFFF');
        so.addVariable('data-file', '".urlencode("stats.php?statType=$graphType&timeSlice=$timeSlice")."');
        so.addParam('allowScriptAccess', 'always' );
        so.addVariable('bg_colour','#eeeeee');
        so.write('connectionStats');
</script>
<form method='GET'>
    <select name='graphType' onChange='this.submit();'>
	<option value='topTen' ".isSelected('topTen',$graphType).">Top ten connections</option>
	<option value='topBlockedRules' ".isSelected('topBlockedRules',$graphType).">Top blocked domains</option>
	<option value='topBlockedUsers' ".isSelected('topBlockedUsers',$graphType).">Top blocked users</option>
    </select>
    :
    <select name='timeSlice' onChange='this.submit();'>
	<option value=60 ".isSelected(60,$timeSlice).">Last 60 minutes</option>
	<option value=360 ".isSelected(360,$timeSlice).">Last 6 hours</options>
	<option value=720 ".isSelected(720,$timeSlice).">Last 12 hours</options>
	<option value=1440 ".isSelected(1440,$timeSlice).">Last 24 hours</options>
    </select>
    <input type=submit value='Update'>
</form>";


include "common_footer.php";

?>