<?php

$TLANG["yes"] = "Si";
$TLANG["no"] = "No";
$TLANG["save"] = "Salva";
$TLANG["close"] = "Chiudi";
$TLANG["edit"] = "Modifica";
$TLANG["send"] = "Invia";
$TLANG["cancel"] = "Annulla";
$TLANG["add"] = "Aggiungi";
$TLANG["remove"] = "Cancella";

$TLANG["login"] = "Autenticazione";
$TLANG["login-username"] = "Nome utente:";
$TLANG["login-password"] = "Password:";
$TLANG["login-submit"] = "Entra";
$TLANG["login-invalid"] = "Accesso negato: credenziali non valide";
$TLANG["login-ok"] = "Benvenuto ";

$TLANG["logout"] = "Esci";
$TLANG["logout-ok"] = "Uscito con successo";

$TLANG["menu-website"] = "Siti web";
$TLANG["menu-rules"] = "Regole";
$TLANG["menu-stats"] = "Statistiche";
$TLANG["menu-users"] = "Utenti e Gruppi";
$TLANG["menu-about"] = "Informazioni su SquidTL";

$TLANG["title-checks"] = "Controlli di coerenza";
$TLANG["title-twitter"] = "Novit&agrave; da Twitter";

$TLANG["rules"] = "Regole";
$TLANG["rules-help"] = "La gestione delle regole comporta lo stabilire:
<ul>
<li>Su <b>cosa</b> agisce questa regola ?
    <ul>
	<li><b>DOMAIN</b> nel caso di una regola afferente ad un certo dominio</li>
	<li><b>URLLIST</b> se desideriamo agire su una predeterminata lista di domini (es. siti porno, warez...)</li>
	<li><b>CATEGORY</b> se vogliamo sfruttare la categorizzazione dei domini (es. news, social networks, malware...)</li>
	<li><b>IDENT</b> nel caso di una regola che agisce su un certo utente riconosciuto dall'identificativo</li>
	<li><b>IP</b> se questa regola deve agire su un certo IP della rete (ad es. se non vogliamo che un certo PC navighi su Internet)</li>
    </ul>
</li>
<li><b>Come</b> agisce questa regola ? Dal <img src='img/flagEdit.png'> pannello di controllo di ogni singola regola si stabilisce:
    <ul>
	<li><b>Quante connessioni</b> (Hits) permettiamo ed in <b>quanto tempo</b> ? Ad esempio, se vogliamo limitare l'uso di Facebook, possiamo indicare un massimo di 10 Hits ogni 15 minuti.<li>
	<li>In genere l'azione della regola &egrave; BLOCK (Blocca) ma possiamo, nel caso di un sistema del tipo <i>proibito-se-non-esplicitamente-permesso</i> permettere con ALLOW</li>
	<li>Si pu&ograve; anche specificare DOVE reindirizzare l'utente: mantenendo il campo vuoto si reindirizza all'URL di default</li>
    </ul>
</li>
<li><b>Quando</b> questa regola &egrave; attiva ? Utilizzato <b>Gestisci periodi</b> per determinare in quali ore e giorni questa regola sar&agrave; attiva</li>
<li>Su <b>quali gruppi di utenti</b> questa regola deve essere applicata ? Per l'afferenza delle regole ad un certo gruppo di utenti dobbiamo spostarci sulla <a href='users.php'>pagina di gestione utenti</a></li>
</ul>
In pi&ugrave; abbiamo a disposizione la possibili&agrave; di attivare/disattivare velocemente ogni singola regola:
<p>
<img src='img/flagGreen.png'> La regola &egrave; ATTIVA: clicca per disattivare.
</p><p>
<img src='img/flagRed.png'> La regola &egrave; DISATTIVATA: clicca per attivare.
</p>
Cliccando su <img src='img/toggleExpand.png'> possiamo avere una panoramica dei periodi assegnati.";
$TLANG["rules-msg-added"] = "Nuova regola aggiunta con successo !";
$TLANG["rules-msg-removed"] = "Regola cancellata con successo";
$TLANG["rules-msg-updated"] = "Regola aggiornata";
$TLANG["rules-msg-panic"] = "Modo panico: tutte le regole disabilitate";
$TLANG["rules-addnew"] = "Aggiungi regola";
$TLANG["rules-import"] = "Importa regole";
$TLANG["rules-export"] = "Esporta regole";
$TLANG["rules-panic"] = "Panico !";
$TLANG["rules-lock"] = "Blocca tutto";
$TLANG["rules-unlock"] = "Sblocca";
$TLANG["rules-traffic-locked"] = "Richiesta di BLOCCO TOTALE DEL TRAFFICO inviata";
$TLANG["rules-traffic-unlocked"] = "Richiesta di SBLOCCO DEL TRAFFICO inviata";
$TLANG["rules-edit"] = "Modifica regola";
$TLANG["rules-add"] = "Aggiungi nuova regola";
$TLANG["rules-type"] = "Tipo:";
$TLANG["rules-redirecturl"] = "Reindirizza su:";
$TLANG["rules-tip-type"] = "Scegli su quale parametro deve basarsi questa regola: Dominio di destinazione, l'identit&agrave; dell'utente o l'IP di provenienza.";
$TLANG["rules-value"] = "Valore:";
$TLANG["rules-tip-value"] = "Inserisci il valore con cui deve essere fatto il <i>matching</i>. Puoi usare le regular expressions.";
$TLANG["rules-action"] = "Azione:";
$TLANG["rules-tip-action"] = "Definisci l'azione nel caso venga attivata questa regola. Attualmente puoi solo <b>bloccare</b>.";
$TLANG["rules-hits"] = "Hits:";
$TLANG["rules-time"] = "Tempo (minuti):";
$TLANG["rules-tip-hitstime"] = "Indica quante connessioni(Hits)  in quanto tempo (Tempo) si devono effettuare prima che si attivi questa regola, reindirizzando l'utente all'URL indicato (vuoto=URL di default). 0 connessioni in 1 minuto equivale a essere reindirizzati sempre.";
$TLANG["rules-activaterule"] = "Attiva regola:";
$TLANG["rules-tip-activaterule"] = "Se hai messo la spunta, questa regola &egrave; attiva.";
$TLANG["rules-context"] = "Contesto:";
$TLANG["rules-tip-context"] = "Specifica il contesto di afferenza della regola:";
$TLANG["rules-deleterule"] = "Cancella regola:";
$TLANG["rules-tip-deleterule"] = "Se hai messo la spunta, questa regola verr&agrave; cancellata definitivamente.";
$TLANG["rules-alltimes"] = "Periodi disponibili";
$TLANG["rules-mytimes"] = "Periodi selezionati";
$TLANG["rules-tip-times"] = "Scegli i periodi di tempo in cui la regola sar&agrave; attiva.";
$TLANG["rules-allgroups"] = "Tutti i gruppi di utenti";
$TLANG["rules-mygroups"] = "Gruppi scelti";
$TLANG["rules-tip-groups"] = "Scegli i gruppi degli utenti afferenti a questa regola";

$TLANG["website"] = "Siti web visitati";
$TLANG["website-purgeall"] = "Azzera la lista";
$TLANG["website-purgeall-confirm"] = "Sicuro di voler azzerare la lista degli accessi ?";
$TLANG["website-purgeall-done"] = "Lista ripulita con successo";
$TLANG["website-help"] = "In questa pagina abbiamo la lista degli ultimi siti web visitati, utilizzata da SquidTL per il calcolo degli accessi. Gli URL sono aggiornati in tempo reale e raggruppati per dominio.
Accanto ad ogni URL abbiamo un icona che indica lo stato:
<p>
<img src='img/statusDeny.png'> Esiste una regola BLOCK per questo URL
</p><p>
<img src='img/statusAllow.png'> Esiste una regola ALLOW per questo URL
</p><p>
<img src='img/statusDisabled.png'> Esiste una regola ma &egrave; attualmente DISABILITATA
</p><p>
<img src='img/flagAdd.png'> Non ci sono regole su questo URL: clicca per aggiungerne una !
</p>
Cliccando su <img src='img/flagView.png'> si apre il popup per modificare la regola. E' possibile effettuare una operazione di pulizia che azzera tutti i contatori, riportanto SquidTL nella situazione iniziale.";

$TLANG["users"] = "Utenti";
$TLANG["users-help"] = "Questa schermata permette di gestire gli utenti (ed i relativi gruppi, pi&ugrave; in basso) di SquidTL appartenenti al proprio contesto.
<p>
Cliccando su <img src='img/flagProperty.png'> si accede al popup di configurazione dell'utente. E' necessario specificare il sistema di autenticazione, ovvero
come SquidTL riconosce questo utente. Sono disponibili tre metodi:<br>
<ul>
<li><b>IDENT</b> nel caso Squid agisca anche come soggetto autenticatore (LDAP, ACL...)</li>
<li><b>IP o Range IP</b> nel caso di intranet. Ad esempio se creiamo l'utente X e tale utente utilizza il PC con IP 10.0.0.20, indicheremo tale IP. I range IP si utilizzano nel caso di sale PC, in cui &egrave; impossibile stabilire a priori quale PC utilizzer&agrave; ogni utente: in questo caso creiamo un utente generico, tipo <i>UtentePC</i>, con il range IP dei PC che pu&ograve; usare.
<li><b>Nulla</b> nel caso di account amministratore, che non avr&agrave; alcun effetto sul proxy.
</ul>
</p><p>
<b>Ogni utente deve afferire ad uno o pi&ugrave; gruppi</b>: per vedere a quali gruppi appartienete un certo utente si pu&ograve; cliccare su <img src='img/toggleExpand.png'>.
</p>";
$TLANG["users-details-title"] = "Dettagli su ";
$TLANG["users-details-totalaccess"] = "Accessi totali: ";
$TLANG["users-properties"] = "Propriet&agrave; utente";
$TLANG["users-context"] = "Contesto";
$TLANG["users-addnew"] = "Aggiungi utente";
$TLANG["users-type"] = "Tipo:";
$TLANG["users-type-0"] = "Disabilitato";
$TLANG["users-type-1"] = "Normale";
$TLANG["users-type-1"] = "Amm. Contesto";
$TLANG["users-type-5"] = "Amministratore";
$TLANG["users-tip-type"] = "Tipo dell'utente. L'utente disabilitato &egrave; paragonato ad un utente sconosciuto.";
$TLANG["users-identifiedby"] = "Identificato da:";
$TLANG["users-identifiedby-ident"] = "Ident";
$TLANG["users-identifiedby-ip"] = "IP o range IP";
$TLANG["users-identifiedby-none"] = "Nulla";
$TLANG["users-tip-identifiedby"] = "Specifica come l'utente (o gruppo di utenti) viene identificato. IP (o range IP) come RegExp oppure l'IDENT indicato da Squid (solo se con autenticazione). Specificare il valore da comparare (espressioni regolari permesse). In caso di utente solo per l'amministrazione, specificare <b>Nulla</b>";
$TLANG["users-allgroups"] = "Tutti i gruppi";
$TLANG["users-mygroups"] = "I miei gruppi";
$TLANG["users-tip-groups"] = "Seleziona i gruppi di regole a cui l'utente appartiene. Usa le frecce per aggiungere o rimuovere i gruppi.";
$TLANG["users-password"] = "Password:";
$TLANG["users-tip-password"] = "Lascia vuoto questo campo se non vuoi cambiare password";
$TLANG["users-msg-deleted"] = "Utente cancellato";
$TLANG["users-msg-adminnodelete"] = "Non posso cancellare l'amministratore !";
$TLANG["users-deleteuser"] = "Cancella utente";
$TLANG["users-tip-deleteuser"] = "Se hai messo la spunta, questo utente verr&agrave; cancellato";

$TLANG["groups"] = "Gruppi";
$TLANG["groups-help"] = "
I gruppi degli utenti permettono di raggruppare diversi account utente (ma anche uno solo) che afferiscono alle stesse regole. Ogni gruppo deve essere collegato ad una o 
pi&ugrave; regole che condizioneranno la navigazione degli utenti appartenenti a tale gruppo.
<p>
Cliccando sull'icona <img src='img/flagGroups.png'> si accede alle propriet&agrave; del gruppo, compresa l'assegnazione o la rimozione delle regole.
</p><p>
Per visualizzare velocemente quali regole afferiscono ad un dato gruppo si pu&ograve; cliccare su <img src='img/toggleExpand.png'>
</p>";
$TLANG["groups-manage"] = "Gestisci gruppi";
$TLANG["groups-addnew"] = "Aggiungi gruppo";
$TLANG["groups-edit"] = "Modifica gruppo";
$TLANG["groups-name"] = "Nome:";
$TLANG["groups-description"] = "Descrizione:";
$TLANG["groups-allrules"] = "Tutte le regole disponibili";
$TLANG["groups-myrules"] = "Le mie regole";
$TLANG["groups-tip-rules"] = "Scegli le regole di questo gruppo";
$TLANG["groups-msg-added"] = "Nuovo gruppo aggiunto con successo";
$TLANG["groups-msg-updated"] = "Gruppo aggiornato con successo";
$TLANG["groups-msg-deleted"] = "Gruppo cancellato";
$TLANG["groups-deletegroup"] = "Cancella gruppo";
$TLANG["groups-tip-deletegroup"] = "Se hai messo la spunta, questo gruppo verr&agrave; cancellato";

$TLANG["context"] = "Contesti";
$TLANG["context-help"] = "L'uso dei contesti permette di configurare un unico SquidTL che serve realt&agrave; disomogenee. Pensiamo, ad esempio, ad una Aula Informatica ed un ufficio, entrambi afferenti al medesimo proxy ma con diversi gestori e responsabili di rete.
Creando due diversi contesti e due amministratori diversi per ogni contesto si rende sia la gestione che l'uso di SquidTL autonomo per entrambi.";

$TLANG["context-manage"] = "Gestisci contesti";
$TLANG["context-addnew"] = "Aggiungi contesto";
$TLANG["context-edit"] = "Modifica contesto";
$TLANG["context-name"] = "Nome contesto:";
$TLANG["context-description"] = "Descrizione:";
$TLANG["context-tip-description"] = "Inserisci una descrizione del contesto, ad esempio <i>Aula informatica 1</i>,<i>Sala riunioni</i>...";
$TLANG["context-iprange"] = "Range IP:";
$TLANG["context-tip-iprange"] = "Indica il range IP delle macchine afferenti a questo contesto utilizzando una RegExp.";
$TLANG["context-delete"] = "Cancella contesto:";
$TLANG["context-tip-delete"] = "Se hai messo la spunta, questo contesto (e relativi utenti, regole e gruppi) verr&agrave; cancellato";

$TLANG["time-manage"] = "Gestici periodi";
$TLANG["time-addnew"] = "Aggiungi nuovo periodo";
$TLANG["time-edit"] = "Cambia periodo";
$TLANG["time-name"] = "Nome:";
$TLANG["time-description"] = "Descrizione:";
$TLANG["time-period"] = "Periodo:";
$TLANG["time-days"] = "Giorni di validit&agrave;:";
$TLANG["time-deletetime"] = "Cancella regola?";
$TLANG["time-allrules"] = "Tutte le regole:";
$TLANG["time-myrules"] = "Le mie regole:";
$TLANG["time-tip-deletetime"] = "Se hai messo la spunta, questa periodo verr&agrave; cancellato.";
$TLANG["time-tip-rules"] = "Scegli le regole che afferiscono a questo periodo";
$TLANG["time-msg-added"] = "Nuovo periodo aggiunto con successo";
$TLANG["time-msg-updated"] = "Periodo aggiornato con successo";
$TLANG["time-msg-deleted"] = "Periodo cancellato con successo";

$TLANG["error-rulenotimeassign"] = "Nessun periodo di validit&agrave; assegnato pertanto questa regola non verr&agrave; mai usata";
$TLANG["error-rulenogroupassign"] = "Nessun gruppo di utenti assegnato pertanto questa regola non verr&agrave; mai usata";
$TLANG["error-noactiverules"] = "Nessuna regola abilitata: tutto il traffico permesso";
$TLANG["error-rulesnoerrors"] = "Controllo coerenza regole: OK !";
$TLANG["error-usernoidentify"] = "Non &egrave; possibile identificare questo utente";
$TLANG["error-usernogroupassign"] = "Nessun gruppo assegnato a questo utente";
$TLANG["error-usersnoerrors"] = "Controllo coerenza utenti: OK !";
$TLANG["error-groupno"] = "Nessun gruppo. Creane qualcuno.";
$TLANG["error-groupnorulesassign"] = "Nessuna regola assegnata a questo gruppo";
$TLANG["error-groupnousersassign"] = "Nessn utente assegnato a questo gruppo";
$TLANG["error-groupsnoerrors"] = "Controllo coerenza gruppi: OK !";
$TLANG["error-eventsblock"] = " BLOCCHI negli ultimi 60 minuti";
$TLANG["error-eventsno"] = "Nessun evento negli ultimi 60 minuti";

?>